#include <iostream> 
#include <windows.h> 

#define BUFSIZE 10 
#define NAMESIZE 10

DWORD WINAPI ClientConn(void *arg);
void SendMSG(SOCKET sock, char* message, int len);
void ErrorHandling(char *message);

int clntNumber=0;
SOCKET clntSocks[10];
HANDLE hMutex;


int main(int argc, char **argv) 
{
    WSADATA wsaData;
    SOCKET servSock;
    SOCKET clntSock;
    SOCKADDR_IN servAddr;
    SOCKADDR_IN clntAddr;
    int clntAddrSize;
    HANDLE hThread;
    DWORD dwThreadID;

    if(argc != 2) 
    {
        printf("Usage : %s \n", argv[0]);
        exit(1);
    }
    
    if(WSAStartup(MAKEWORD(2, 2), &wsaData) != 0) 
    {
        ErrorHandling("WSAStartup() error!");
    }

    hMutex=CreateMutex(NULL, FALSE, NULL);
    if(hMutex==NULL) 
    {
        ErrorHandling("CreateMutex() error");
    }

    servSock=socket(PF_INET, SOCK_STREAM, 0);
    if(servSock == INVALID_SOCKET) 
    {
        ErrorHandling("socket() error");
    }

    memset(&servAddr, 0, sizeof(servAddr));
    servAddr.sin_family     = AF_INET;
    servAddr.sin_addr.s_addr= htonl(INADDR_ANY);
    servAddr.sin_port       = htons(atoi(argv[1]));


    printf("server ip      : [%s]\n", inet_ntoa(servAddr.sin_addr));
    printf("port           : [%d]\n", atoi(argv[1]));

    if(bind(servSock, (SOCKADDR*) &servAddr, sizeof(servAddr))==SOCKET_ERROR) 
    {
        ErrorHandling("bind() error");
    }

    if(listen(servSock, 5)==SOCKET_ERROR) 
    {
        ErrorHandling("listen() error");
    }

    while(1) 
    {
        clntAddrSize= sizeof(clntAddr);
        clntSock    = accept(servSock, (SOCKADDR*)&clntAddr, &clntAddrSize);
        if(clntSock == INVALID_SOCKET)
        {
            ErrorHandling("accept() error");
        }
        WaitForSingleObject(hMutex, INFINITE);

        clntSocks[clntNumber++]=clntSock;
        if(clntNumber >= 10)
        {
            ErrorHandling("   ʰ");
            return 0;
        }
        ReleaseMutex(hMutex);

        printf("ο , Ŭ̾Ʈ IP : %s \n", inet_ntoa(clntAddr.sin_addr));
        hThread = (HANDLE)_beginthreadex(NULL, 0, (unsigned (__stdcall *) (void *))ClientConn, (void*)clntSock, 0, (unsigned *)&dwThreadID);
        if(hThread == 0) 
        {
            ErrorHandling("  ");
        }
    }
    WSACleanup();
    return 0;
}

DWORD WINAPI ClientConn(void *arg) 
{
    SOCKET clntSock=(SOCKET)arg;
    int strLen=0;
    char message[BUFSIZE];
    int i;
    while(1)
    {
        // ۰ 10
        strLen = recv(clntSock, message, BUFSIZE, 0);
        if(strLen <= 0)
        {
            printf("recv  0   [%d] \n", strLen);
            break;
        }
 
        printf("Ŭ̾Ʈ id  [%d]\n", clntSock); 
        printf("       [%d]\n", strLen);
        printf("޽         [%s]\n", message);
        SendMSG(clntSock, message, strLen);
    }
    WaitForSingleObject(hMutex, INFINITE);
    return 0;
}

void SendMSG(SOCKET sock, char* message, int len) 
{
    send(sock, message, len, 0);
}

void ErrorHandling(char *message) 
{
    fputs(message, stderr);
    fputc('\n', stderr);
    exit(1);
}

